print("Mario Bros Tweaks Loading.")

--Making a console variable to enable or disable ring drain
local allowRingDrain = CV_RegisterVar({
	name = "tu_mariobrosringdrain",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

--this disables Kuribo's shoe
if skins["mario"] then
	SH_SHOE = INT8_MIN
else
	--doubles as a script cancel if mario is not loaded
	return nil
end

--simple table to check characters compatible with mario powerups
local isItABro = {}
isItABro["mario"] = true
isItABro["luigi"] = true
--another table to check which mario powerups or shields should have ring drain.
--key is the shield flag, value is the name of the shield in string form
local ringDrainShields = {}
ringDrainShields[SH_MINI] = "Mini Mushroom"
ringDrainShields[SH_BALLOON] = "P-Balloon"

--variable to track the minimum tics before losing a ring to mini
local defaultMiniTics = 1 * TICRATE

--another function to handle the removal of the proper shield
local function removeShield(player, shieldCheck)
	player.powers[pw_shield] = 0
	chatprintf(player, "You ran out of rings, no more " .. shieldCheck .. "...")
end

--mini mushroom has ring drain now
local function ringDrainMini(player)
	--obligatory nil check
	if player.mo == nil then
		return nil
	--we don't care if player is a tagger or not a bro
	--(player.pflags & PF_TAGIT) or
	elseif isItABro[player.mo.skin] == nil then
		return nil
	--final check to ensure the player has minitics
	elseif player.miniTics == nil then
		player.miniTics = defaultMiniTics
	end
	
	--Player is not nil, is a mario bro, and is IT.
	--The code will continue now assuming all the above.
	
	--Do the shield check now to save an instruction
	local shieldCheck = ringDrainShields[player.powers[pw_shield]]
	--player is both a hider and playing a mario bro, execute the code
	if shieldCheck != nil then
	--count down the tics for each frame that mario is mini
		player.miniTics = $ - 1
	elseif player.miniTics != defaultMiniTics then
		--Set minitics to default if not using ring drain power
		player.miniTics = defaultMiniTics
	end
	
	--do checks based on tics
	--remove a ring if the tics are go
	if player.miniTics <= 0 then
		--remove mini mush if the ring count is zero
		if player.rings <= 0 then
		--call the shield removal function
			removeShield(player, shieldCheck)
		else
			--remove a ring and reset tics
			--P_GivePlayerRings(player, -1)
			player.rings = $ - 1
		end
		player.miniTics = defaultMiniTics
	end
end

addHook("PostThinkFrame", do
	--Check if ringdrain is enabled before running code.
	if allowRingDrain.value == 1 then
		for player in players.iterate do
			ringDrainMini(player)
		end
	end
end)

print("Mario Bros Tweaks finished Loading.")